Fix systemd: reload stops metaproxy MP-620
[metaproxy-moved-to-github.git] / debian / metaproxy.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          metaproxy
4 # Required-Start:    $local_fs $remote_fs $network $named $time
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Controls the metaproxy daemon
9 # Description:       Controls the Metaproxy daemon /usr/bin/metaproxy .
10 ### END INIT INFO
11
12 # Do NOT "set -e"
13
14 # PATH should only include /usr/* if it runs after the mountnfs.sh script
15 PATH=/sbin:/usr/sbin:/bin:/usr/bin
16 NAME=metaproxy
17 DAEMON=/usr/bin/$NAME
18 DAEMON_OPTS="-h"
19 PIDFILE=/var/run/$NAME.pid
20 SCRIPTNAME=/etc/init.d/$NAME
21
22 # Exit if the package is not installed
23 [ -x "$DAEMON" ] || exit 0
24
25 # Read user information
26 . /etc/metaproxy/metaproxy.user
27
28 # Read configuration variable file if it is present
29 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
30
31 # Load the VERBOSE setting and other rcS variables
32 . /lib/init/vars.sh
33
34 # Define LSB log_* functions.
35 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
36 . /lib/lsb/init-functions
37
38 #
39 # Function that starts the daemon/service
40 #
41 do_start()
42 {
43         # Return
44         #   0 if daemon has been started
45         #   1 if daemon was already running
46         #   2 if daemon could not be started
47         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
48                 || return 1
49         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
50                 $DAEMON_OPTS \
51                 || return 2
52         # Add code here, if necessary, that waits for the process to be ready
53         # to handle requests from services started subsequently which depend
54         # on this one.  As a last resort, sleep for some time.
55 }
56
57 #
58 # Function that stops the daemon/service
59 #
60 do_stop()
61 {
62         # Return
63         #   0 if daemon has been stopped
64         #   1 if daemon was already stopped
65         #   2 if daemon could not be stopped
66         #   other if a failure occurred
67         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
68         RETVAL="$?"
69         [ "$RETVAL" = 2 ] && return 2
70         # Wait for children to finish too if this is a daemon that forks
71         # and if the daemon is only ever run from this initscript.
72         # If the above conditions are not satisfied then add some other code
73         # that waits for the process to drop all resources that could be
74         # needed by services started subsequently.  A last resort is to
75         # sleep for some time.
76         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
77         #[ "$?" = 2 ] && return 2
78         # Many daemons don't delete their pidfiles when they exit.
79         rm -f $PIDFILE
80         return "$RETVAL"
81 }
82
83 #
84 # Function that sends a SIGUSR1 to the daemon/service
85 #
86 do_reload() {
87         #
88         # If the daemon can reload its configuration without
89         # restarting (for example, when it is sent a SIGHUP),
90         # then implement that here.
91         
92         $DAEMON -t $DAEMON_OPTS > /dev/null || return 2
93         start-stop-daemon --stop --signal USR1 --quiet --retry=5 --pidfile $PIDFILE --name $NAME
94         RETVAL="$?"
95         # Return if daemon could not be stopped
96         [ "$RETVAL" = 2 ] && return 2
97         # daemon not running or stopped
98         rm -f $PIDFILE
99         # Return if it was not running, in which case we don't start it
100         [ "$RETVAL" = 1 ] && return 0
101         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
102                 $DAEMON_OPTS \
103                 || return 2
104         return 0
105 }
106
107 case "$1" in
108   start)
109         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
110         do_start
111         case "$?" in
112                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
113                 2) [ "$VERBOSE" = no ] && \
114                                 log_daemon_msg "Starting $DESC" "$NAME"
115                         log_end_msg 1 
116                 ;;
117         esac
118         ;;
119   stop)
120         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
121         do_stop
122         case "$?" in
123                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
124                 2) [ "$VERBOSE" = no ] && \
125                                 log_daemon_msg "Stopping $DESC" "$NAME"
126                         log_end_msg 1 
127                 ;;
128         esac
129         ;;
130   reload|force-reload)
131         #
132         # If do_reload() is not implemented then leave this commented out
133         # and leave 'force-reload' as an alias for 'restart'.
134         #
135         # our reload makes a new PID. systemd doesn't allow it. MP-620
136         if test -n "$_use_systemctl"; then
137                 log_daemon_msg "Using systemd. Not reloading $DESC" "$NAME"
138                 log_end_msg 0
139         else
140                 log_daemon_msg "Reloading $DESC" "$NAME"
141                 do_reload
142                 log_end_msg $?
143         fi
144         ;;
145   restart)
146         #
147         # If the "reload" option is implemented then remove the
148         # 'force-reload' alias
149         #
150         log_daemon_msg "Restarting $DESC" "$NAME"
151         do_stop
152         case "$?" in
153           0|1)
154                 do_start
155                 case "$?" in
156                         0) log_end_msg 0 ;;
157                         1) log_end_msg 1 ;; # Old process is still running
158                         *) log_end_msg 1 ;; # Failed to start
159                 esac
160                 ;;
161           *)
162                 # Failed to stop
163                 log_end_msg 1
164                 ;;
165         esac
166         ;;
167   checkconfig)
168         $DAEMON -t $DAEMON_OPTS > /dev/null || exit 2
169         exit 0
170         ;;
171   status)
172         status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
173         ;;
174   *)
175         echo "Usage: $SCRIPTNAME {start|stop|status|restart|reload|force-reload}" >&2
176         exit 3
177         ;;
178 esac
179
180 :